/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef RAMPART_ISSUED_H
#define RAMPART_ISSUED_H

#include <rampart_context.h>
#include <rampart_issued_token.h>

#ifdef __cplusplus
extern "C"
{
#endif

    /**
     * 
     * @param rampart_context
     * @param env pointer to environment struct,Must not be NULL.
     * @param sec_node
     * @param sign_parts
     * @returns status of the op.                                                                                                        
     * AXIS2_SUCCESS on success and AXIS2_FAILURE on error          
     */

	AXIS2_EXTERN axis2_status_t AXIS2_CALL
	rampart_issued_supporting_token_build(
		rampart_context_t *rampart_context, 
        const axutil_env_t *env, 
		axiom_node_t *sec_node,
        axutil_array_list_t *sign_parts);



#ifdef __cplusplus
}
#endif

#endif

